
IF(WIN32)
	INCLUDE("${CMAKE_CURRENT_LIST_DIR}/common.win32.cmake")
ELSE()
	INCLUDE("${CMAKE_CURRENT_LIST_DIR}/common.unix.cmake")
ENDIF()

# to install zlib for windows
# cmake .; in zlib source root and build vc++ solution(INSTALL project)
# you have to make sure to install zlib in $ENV{PROGRAMFILES} directory(otherwise cmake fails to find it)
MESSAGE(STATUS "ZLIB_ROOT=$ENV{ZLIB_ROOT}")
FIND_PACKAGE(ZLIB)

IF(ZLIB_FOUND)
	MESSAGE(STATUS "ZLIB_INCLUDE_DIRS=${ZLIB_INCLUDE_DIRS}")
	MESSAGE(STATUS "ZLIB_LIBRARIES=${ZLIB_LIBRARIES}")
ELSE()
	MESSAGE(STATUS "ZLIB not found, ZlibInputStream and ZlibOutputStream not available")
	SET_PROPERTY(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS "NLIB_NO_ZLIB")
ENDIF()

