
IF(DEFINED NLIB_IMPORT_NX_MISC)
  RETURN()
ENDIF()

IF(${CMAKE_BUILD_TYPE} MATCHES "Debug")
  SET(NLIB_POSTFIX ${CMAKE_DEBUG_POSTFIX})
ELSE()
  SET(NLIB_POSTFIX ${CMAKE_RELEASE_POSTFIX})
ENDIF()

IF(BUILD_SHARED_LIBS)
  SET(NLIB_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX})
  SET(NLIB_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
  SET(NLIB_LIBTYPE SHARED)
ELSE()
  SET(NLIB_PREFIX ${CMAKE_STATIC_LIBRARY_PREFIX})
  SET(NLIB_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
  SET(NLIB_LIBTYPE STATIC)
ENDIF()

IF(NOT EXISTS "${NLIB_RELEASE_ROOT}/include")
  FILE(MAKE_DIRECTORY "${NLIB_RELEASE_ROOT}/include")
ENDIF()

#
# nx_misc
#
IF(NOT TARGET nx_misc)
  ADD_LIBRARY(nx_misc ${NLIB_LIBTYPE} IMPORTED)
  SET_PROPERTY(TARGET nx_misc PROPERTY IMPORTED_LOCATION "${NLIB_DIR}/${NLIB_PREFIX}nx_misc${NLIB_POSTFIX}${NLIB_SUFFIX}")
  SET_PROPERTY(TARGET nx_misc PROPERTY IMPORTED_IMPLIB "${NLIB_DIR}/${CMAKE_IMPORT_LIBRARY_PREFIX}nx_misc${NLIB_POSTFIX}${CMAKE_IMPORT_LIBRARY_SUFFIX}")
  SET_PROPERTY(TARGET nx_misc APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${NLIB_RELEASE_ROOT}/include")
ENDIF()
SET_PROPERTY(TARGET nx_misc APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${ZLIB_INCLUDE_DIRS}")
SET_PROPERTY(TARGET nx_misc APPEND PROPERTY INTERFACE_LINK_LIBRARIES "${ZLIB_LIBRARIES}")
SET_PROPERTY(TARGET nx_misc APPEND PROPERTY INTERFACE_COMPILE_DEFINITIONS "__STDC_LIMIT_MACROS;__STDC_CONSTANT_MACROS;__STDC_FORMAT_MACROS;__STDC_WANT_SECURE_LIB__=1")
IF(UNIX)
  IF(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    SET_PROPERTY(TARGET nx_misc APPEND PROPERTY INTERFACE_LINK_LIBRARIES pthread rt execinfo)
  ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    SET_PROPERTY(TARGET nx_misc APPEND PROPERTY INTERFACE_LINK_LIBRARIES pthread)
  ELSE()
    SET_PROPERTY(TARGET nx_misc APPEND PROPERTY INTERFACE_LINK_LIBRARIES pthread rt)
  ENDIF()
ENDIF()

SET(NLIB_IMPORT_NX_MISC TRUE)

