﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_
#define INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_

#include "nn/nlib/InputConverterStream.h"

NLIB_NAMESPACE_BEGIN

class InputStream;

namespace detail {

class NLIB_VIS_PUBLIC Base64InputTransform NLIB_FINAL : public InputTransform {
 public:
    Base64InputTransform();

    virtual errno_t Transform(InputStream* is, void* p, size_t nBytes,
                              size_t* written) NLIB_OVERRIDE;
    virtual void* GetWorkBuffer(size_t* n) NLIB_OVERRIDE;
    virtual errno_t OnSetStream(InputStream* is) NLIB_OVERRIDE;
    virtual errno_t OnClose() NLIB_OVERRIDE;

 private:
    unsigned char m_DropBuf[4];
    // Read 4 bytes and write 3 bytes ->
    //   Read 256 bytes and buffer 192 bytes
    unsigned char m_Buf[192];

    NLIB_DISALLOW_COPY_AND_ASSIGN(Base64InputTransform);
};

}  // namespace detail

#ifndef NLIB_DOXYGEN
typedef InputConverterStreamTempl<detail::Base64InputTransform> Base64InputStream;
#else
// NOTE: we don't use typedef for doxygen.
class NLIB_VIS_PUBLIC Base64InputStream NLIB_FINAL
    : public InputConverterStreamTempl<detail::Base64InputTransform> {};
#endif

NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_BASE64INPUTSTREAM_H_
