﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONFIG_CTR_H_
#define INCLUDE_NN_NLIB_CONFIG_CTR_H_
#ifndef INCLUDE_NN_NLIB_CONFIG_H_
# error do not include directly
#endif

#ifdef NN_PLATFORM_CTR

#include "nn/assert.h" // NOLINT for NN_ASSERT

extern bool nlib_init_ctrsample(bool useFs);
extern void nlib_terminate_ctrsample();

#ifdef NLIB_CTR_SAMPLE_USEFILE
# define NLIB_CTR_SAMPLE_INIT_ARG true
#else
# define NLIB_CTR_SAMPLE_INIT_ARG false
#endif

#define NLIB_PATHMAPPER_FORSAMPLE \
    nlib_ns::NativePathMapper g_PathMapper; \
    inline void InitPathMapperForSample() { \
        g_PathMapper.AddMap("rom:/", "nlibpath:///readonly/"); \
        g_PathMapper.AddMap("sdmc:/", "nlibpath:///readwrite/"); \
    }

#define NLIB_MAINFUNC \
extern "C" void nnMain() { \
    if (!nlib_init_ctrsample(NLIB_CTR_SAMPLE_INIT_ARG)) return; \
    bool result = SampleMain(0, NULL); \
    nlib_printf(result ? "OK\n" : "NG\n"); \
    nlib_terminate_ctrsample(); \
}

#define NLIB_ASSERT NN_ASSERT
#define NLIB_ASSERT_NOERR(e) NN_ASSERTMSG(((e) == 0), "%s", nlib_error_string(e))

#define NLIB_ALIGNAS(x) __align(x)
#define NLIB_ALIGNOF(tp) __alignof__(tp)

template<class T> inline void nlib_unused_(const T&) {}
#define NLIB_UNUSED(x) ::nlib_unused_(x)

#define NLIB_HAS_VIRTUALMEMORY
#define NLIB_HAS_STDHEADER_TIME

#endif
#endif  // INCLUDE_NN_NLIB_CONFIG_CTR_H_
