﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CRC_H_
#define INCLUDE_NN_NLIB_CRC_H_

#include "nn/nlib/Config.h"

NLIB_NAMESPACE_BEGIN

class NLIB_VIS_PUBLIC Crc32 NLIB_FINAL {
 public:
    Crc32() NLIB_NOEXCEPT;
    errno_t Update(const void* buf, size_t len) NLIB_NOEXCEPT NLIB_NONNULL;
    errno_t Update(int b) NLIB_NOEXCEPT;
    uint32_t GetValue() const NLIB_NOEXCEPT;

 private:
    uint32_t m_Value;
};

NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_CRC_H_
