﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_INTTYPES_H_
#define INCLUDE_NN_NLIB_INTTYPES_H_

#ifdef _MSC_VER

#define PRId8 "d"
#define PRId16 "hd"
#define PRId32 "I32d"
#define PRId64 "I64d"
#define PRIdLEAST16 "hd"
#define PRIdLEAST32 "I32d"
#define PRIdLEAST64 "I64d"
#define PRIdFAST16 "hd"
#define PRIdFAST32 "I32d"
#define PRIdFAST64 "I64d"
#define PRIdPTR "Id"

#define PRIi8 "i"
#define PRIi16 "hi"
#define PRIi32 "I32i"
#define PRIi64 "I64i"
#define PRIiLEAST16 "hi"
#define PRIiLEAST32 "I32i"
#define PRIiLEAST64 "I64i"
#define PRIiFAST16 "hi"
#define PRIiFAST32 "I32i"
#define PRIiFAST64 "I64i"
#define PRIiPTR "Ii"

#define PRIu8 "u"
#define PRIu16 "hu"
#define PRIu32 "I32u"
#define PRIu64 "I64u"
#define PRIuLEAST16 "hu"
#define PRIuLEAST32 "I32u"
#define PRIuLEAST64 "I64u"
#define PRIuFAST16 "hu"
#define PRIuFAST32 "I32u"
#define PRIuFAST64 "I64u"
#define PRIuPTR "Iu"

#define PRIx8 "x"
#define PRIx16 "hx"
#define PRIx32 "I32x"
#define PRIx64 "I64x"
#define PRIxLEAST16 "hx"
#define PRIxLEAST32 "I32x"
#define PRIxLEAST64 "I64x"
#define PRIxFAST16 "hx"
#define PRIxFAST32 "I32x"
#define PRIxFAST64 "I64x"
#define PRIxPTR "Ix"

#define PRIX8 "X"
#define PRIX16 "hX"
#define PRIX32 "I32X"
#define PRIX64 "I64X"
#define PRIXLEAST16 "hX"
#define PRIXLEAST32 "I32X"
#define PRIXLEAST64 "I64X"
#define PRIXFAST16 "hX"
#define PRIXFAST32 "I32X"
#define PRIXFAST64 "I64X"
#define PRIXPTR "IX"

#define PRIo8 "o"
#define PRIo16 "ho"
#define PRIo32 "I32o"
#define PRIo64 "I64o"
#define PRIoLEAST16 "ho"
#define PRIoLEAST32 "I32o"
#define PRIoLEAST64 "I64o"
#define PRIoFAST16 "ho"
#define PRIoFAST32 "I32o"
#define PRIoFAST64 "I64o"
#define PRIoPTR "Io"

#define PRIdMAX "I64d"
#define PRIiMAX "I64i"
#define PRIuMAX "I64u"
#define PRIxMAX "I64x"
#define PRIXMAX "I64X"
#define PRIoMAX "I64o"

#define SCNd8 "d"
#define SCNd16 "hd"
#define SCNd32 "I32d"
#define SCNd64 "I64d"
#define SCNdLEAST16 "hd"
#define SCNdLEAST32 "I32d"
#define SCNdLEAST64 "I64d"
#define SCNdFAST16 "hd"
#define SCNdFAST32 "I32d"
#define SCNdFAST64 "I64d"
#ifdef _WIN64
#define SCNdPTR "I64d"
#else
#define SCNdPTR "Id"
#endif

#define SCNi8 "i"
#define SCNi16 "hi"
#define SCNi32 "I32i"
#define SCNi64 "I64i"
#define SCNiLEAST16 "hi"
#define SCNiLEAST32 "I32i"
#define SCNiLEAST64 "I64i"
#define SCNiFAST16 "hi"
#define SCNiFAST32 "I32i"
#define SCNiFAST64 "I64i"
#ifdef _WIN64
#define SCNiPTR "I64i"
#else
#define SCNiPTR "Ii"
#endif

#define SCNu8 "u"
#define SCNu16 "hu"
#define SCNu32 "I32u"
#define SCNu64 "I64u"
#define SCNuLEAST16 "hu"
#define SCNuLEAST32 "I32u"
#define SCNuLEAST64 "I64u"
#define SCNuFAST16 "hu"
#define SCNuFAST32 "I32u"
#define SCNuFAST64 "I64u"
#ifdef _WIN64
#define SCNuPTR "I64u"
#else
#define SCNuPTR "Iu"
#endif

#define SCNx8 "x"
#define SCNx16 "hx"
#define SCNx32 "I32x"
#define SCNx64 "I64x"
#define SCNxLEAST16 "hx"
#define SCNxLEAST32 "I32x"
#define SCNxLEAST64 "I64x"
#define SCNxFAST16 "hx"
#define SCNxFAST32 "I32x"
#define SCNxFAST64 "I64x"
#ifdef _WIN64
#define SCNxPTR "I64x"
#else
#define SCNxPTR "Ix"
#endif

#define SCNo8 "o"
#define SCNo16 "ho"
#define SCNo32 "I32o"
#define SCNo64 "I64o"
#define SCNoLEAST16 "ho"
#define SCNoLEAST32 "I32o"
#define SCNoLEAST64 "I64o"
#define SCNoFAST16 "ho"
#define SCNoFAST32 "I32o"
#define SCNoFAST64 "I64o"
#ifdef _WIN64
#define SCNoPTR "I64o"
#else
#define SCNoPTR "Io"
#endif

#define SCNdMAX "I64d"
#define SCNiMAX "I64i"
#define SCNuMAX "I64u"
#define SCNxMAX "I64x"
#define SCNoMAX "I64o"

#elif defined(NLIB_64BIT)
#error Sorry, not supported yet.
#else
#error Sorry, not supported yet.
#endif

#endif  // INCLUDE_NN_NLIB_INTTYPES_H_
