﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_NATIVEPATHMAPPER_H_
#define INCLUDE_NN_NLIB_NATIVEPATHMAPPER_H_

#include "nn/nlib/Platform.h"
#include "nn/nlib/Nlist.h"

NLIB_NAMESPACE_BEGIN

class NativePathMapper {
 public:
    NativePathMapper() NLIB_NOEXCEPT {}
    NLIB_VIS_PUBLIC ~NativePathMapper() NLIB_NOEXCEPT;
    NLIB_VIS_PUBLIC errno_t AddMap(const char* nativePrefix, const char* uriPrefix) NLIB_NOEXCEPT;
    NLIB_VIS_PUBLIC errno_t ResolvePath(size_t* count, char* native, size_t n,
                                        const char* uriPath) const NLIB_NOEXCEPT;
    template <size_t N>
    errno_t ResolvePath(size_t* count, char (&native)[N],
                        const char* uriPath) const NLIB_NOEXCEPT {
        return ResolvePath(count, native, N, uriPath);
    }

 private:
    struct ConvertMap {
        char* uri_prefix;
        size_t uri_prefix_len;
        char* native_prefix;
    };
    Nlist<ConvertMap> m_Map;

    NLIB_DISALLOW_COPY_AND_ASSIGN(NativePathMapper);
};

NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_NATIVEPATHMAPPER_H_
