﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_MSGPACK_JSONRPC_JSONRPCSERVEREXEC_H_
#define INCLUDE_NN_NLIB_MSGPACK_JSONRPC_JSONRPCSERVEREXEC_H_

#include "nn/nlib/Config.h"
#include "nn/nlib/Nlist.h"
#include "nn/nlib/OutputStream.h"
#include "nn/nlib/UniquePtr.h"
#include "nn/nlib/ReallocOutputStream.h"
#include "nn/nlib/msgpack/MpObject.h"
#include "nn/nlib/msgpack/jsonrpc/JsonRpcResponse.h"

#if defined(_MSC_VER) && defined(nx_msgpack_EXPORTS)
#undef NLIB_VIS_PUBLIC
#define NLIB_VIS_PUBLIC NLIB_WINEXPORT
#endif

NLIB_NAMESPACE_BEGIN
namespace msgpack {
namespace jsonrpc {

enum JsonRpcServerFuncCallError {
    JSONSERVER_OK = 0,
    JSONSERVER_PARSE_ERROR = -32700,
    JSONSERVER_INVALID_REQUEST = -32600,
    JSONSERVER_METHOD_NOT_FOUND = -32601,
    JSONSERVER_INVALID_PARAMS = -32602,
    JSONSERVER_INTERNAL_ERROR = -32603
};

typedef JsonRpcServerFuncCallError (*JsonRpcServerFunc)(MpObject& param,  // NOLINT
                                                        JsonRpcResponse& response);  // NOLINT

NLIB_VIS_PUBLIC errno_t AddJsonRpcServerMethod(const char* method, JsonRpcServerFunc func);
NLIB_VIS_PUBLIC JsonRpcServerFunc GetJsonRpcServerMethod(const char* method);
NLIB_VIS_PUBLIC void ClearJsonRpcServerMethodTable();

NLIB_VIS_PUBLIC size_t JsonRpcServerExec(const void* p, size_t n,
                                         ReallocOutputStream::UniquePtrType* ptr);

}  // namespace jsonrpc
}  // namespace msgpack
NLIB_NAMESPACE_END

#if defined(_MSC_VER) && defined(nx_msgpack_EXPORTS)
#undef NLIB_VIS_PUBLIC
#define NLIB_VIS_PUBLIC NLIB_WINIMPORT
#endif

#endif  // INCLUDE_NN_NLIB_MSGPACK_JSONRPC_JSONRPCSERVEREXEC_H_
