﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_TESTING_TESTING_H_
#define INCLUDE_NN_NLIB_TESTING_TESTING_H_

#include "nn/nlib/Config.h"

#ifndef NLIB_USE_GTEST
#include "nn/nlib/testing/NTest.h"
#include "nn/nlib/testing/Pred.h"
#include "nn/nlib/testing/Printer.h"
#include "nn/nlib/testing/ParamValue.h"
#include "nn/nlib/testing/ParamType.h"

namespace testing = ::nlib_ns::testing;
NLIB_NAMESPACE_BEGIN
namespace testing {
inline void InitGoogleTest(int* argc, char** argv) { InitNintendoTest(argc, argv); }
inline void InitGoogleTest(int* argc, wchar_t** argv) { InitNintendoTest(argc, argv); }
#define NLIB_TESTING_OSTREAM ::nlib_ns::testing::detail_func::DummyStream
}  // namespace testing
NLIB_NAMESPACE_END
#else
// See: https://code.google.com/p/googletest/
#include "gtest/gtest.h"

#define NLIB_TESTING_OSTREAM std::ostream
namespace testing {
inline void InitNintendoTest(int* argc, char** argv) { InitGoogleTest(argc, argv); }
inline void InitNintendoTest(int* argc, wchar_t** argv) { InitGoogleTest(argc, argv); }
}

#endif

#endif  // INCLUDE_NN_NLIB_TESTING_TESTING_H_
