﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_UNICODE_STRINGPREP_H_
#define INCLUDE_NN_NLIB_UNICODE_STRINGPREP_H_

#include "nn/nlib/Config.h"

NLIB_NAMESPACE_BEGIN
namespace unicode {

struct StringPrepMapResult {
    size_t n;
    uint32_t code[4];
};

class StringPrep NLIB_FINAL {
    // See RFC3454
 public:
    NLIB_VIS_PUBLIC static bool InTableA1(uint32_t utf32) NLIB_NOEXCEPT;

    NLIB_VIS_PUBLIC static bool InTableB1(uint32_t utf32) NLIB_NOEXCEPT;
    NLIB_VIS_PUBLIC static bool MapTableB2(uint32_t utf32, StringPrepMapResult* m) NLIB_NOEXCEPT;
    NLIB_VIS_PUBLIC static bool MapTableB3(uint32_t utf32, StringPrepMapResult* m) NLIB_NOEXCEPT;

    static bool InTableC11(uint32_t utf32) NLIB_NOEXCEPT { return utf32 == 0x0020; }
    NLIB_VIS_PUBLIC static bool InTableC12(uint32_t utf32) NLIB_NOEXCEPT;
    static bool InTableC21(uint32_t utf32) NLIB_NOEXCEPT {
        return utf32 < 0x0020 || utf32 == 0x007F;
    }
    NLIB_VIS_PUBLIC static bool InTableC22(uint32_t utf32) NLIB_NOEXCEPT;

    NLIB_VIS_PUBLIC static bool InTableC3(uint32_t utf32) NLIB_NOEXCEPT;
    NLIB_VIS_PUBLIC static bool InTableC4(uint32_t utf32) NLIB_NOEXCEPT;
    static bool InTableC5(uint32_t utf32) NLIB_NOEXCEPT {
        return utf32 >= 0xD800 && utf32 <= 0xDFFF;
    }
    static bool InTableC6(uint32_t utf32) NLIB_NOEXCEPT {
        return utf32 >= 0xFFF9 && utf32 <= 0xFFFD;
    }
    static bool InTableC7(uint32_t utf32) NLIB_NOEXCEPT {
        return utf32 >= 0x2FF0 && utf32 <= 0x2FFB;
    }
    NLIB_VIS_PUBLIC static bool InTableC8(uint32_t utf32) NLIB_NOEXCEPT;
    static bool InTableC9(uint32_t utf32) NLIB_NOEXCEPT {
        return utf32 == 0xE0001 || (utf32 >= 0xE0020 && utf32 <= 0xE007F);
    }
    NLIB_VIS_PUBLIC static bool InTableD1(uint32_t utf32) NLIB_NOEXCEPT;
    NLIB_VIS_PUBLIC static bool InTableD2(uint32_t utf32) NLIB_NOEXCEPT;
};

}  // namespace unicode
NLIB_NAMESPACE_END

#endif  // INCLUDE_NN_NLIB_UNICODE_STRINGPREP_H_
