
[CmdletBinding()]
Param(
  [Parameter(Mandatory=$True,Position=1)][string]$target
)

# cygwin workaround
$env:path = ((($env:path -split ';') -notlike '*cygwin*') -join ';')

switch ($target) {
  "vc120amd64" {
    $generator = "Visual Studio 12 2013 Win64"
  }
  "vc120" {
    $generator = "Visual Studio 12 2013"
  }
  "vc110amd64" {
    $generator = "Visual Studio 11 2012 Win64"
  }
  "vc110" {
    $generator = "Visual Studio 11 2012"
  }
  "vc100" {
    $generator = "Visual Studio 10 2010"
  }
  "vc90" {
    $generator = "Visual Studio 9 2008"
  }
  default {
    Write-Host "Usage: gen-sln.ps1 target(e.g. vc120)"
    exit
  }
}

Push-Location

try {
  Set-Location (Split-Path $script:myInvocation.MyCommand.path -parent)
  New-Item ./$target/Release -type directory -force
  cd ./$target/Release
  cmake -DCMAKE_BUILD_TYPE=Release -G "$generator" ../..
} catch [Exception] {
  Write-Host "Error has occured($target/Release)"
}

try {
  Set-Location (Split-Path $script:myInvocation.MyCommand.path -parent)
  New-Item ./$target/Debug -type directory -force
  cd ./$target/Debug
  cmake -DCMAKE_BUILD_TYPE=Debug -G "$generator" ../..
} catch [Exception] {
  Write-Host "Error has occured($target/Debug)"
}

Pop-Location

