#!/bin/sh

target=$1
case ${target} in
	"vc90" ) GEN="Visual Studio 9 2008" ;;
	"vc100" ) GEN="Visual Studio 10 2010" ;;
	"vc110" ) GEN="Visual Studio 11 2012" ;;
	"vc110amd64" ) GEN="Visual Studio 11 2012" ;;
#	"vc110dllamd64" ) GEN="Visual Studio 11 2012" ;;
	"vc120" ) GEN="Visual Studio 12 2013" ;;
	"vc120amd64" ) GEN="Visual Studio 12 2013" ;;
#	"vc120dllamd64" ) GEN="Visual Studio 12 2013" ;;
	* ) echo "A Generator script for Visual Studio"
		echo "Usage: $0 target(e.g. vc120)"
	    exit 1 ;;
esac

case ${target} in
	*dll* ) dll="-DNLIB_DLL=1" ;;
	* ) dll= ;;
esac

case ${target} in
	*amd64 ) amd64=" Win64" ;;
	* ) amd64= ;;
esac

echo "Generator is ${GEN}${amd64}"

IFS=\

cd $(dirname $0)

PATH=${PATH//\/usr\/local\/bin/}
PATH=${PATH//\/usr\/bin/}
PATH=$(echo $PATH | /usr/bin/sed 's/^:*//; s/:*$//; s/::/:/g')
/usr/bin/which cmake

(/bin/mkdir -p ${target}/Release && cd ${target}/Release && cmake -DCMAKE_BUILD_TYPE=Release ${dll} -G "${GEN}${amd64}" ../../)
(/bin/mkdir -p ${target}/Debug && cd ${target}/Debug && cmake -DCMAKE_BUILD_TYPE=Debug ${dll} -G "${GEN}${amd64}" ../../)


