﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2015 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#include <string>
#include "nn/nlib/FileInputStream.h"
#include "nn/nlib/TextReader.h"
#include "nn/nlib/NativePathMapper.h"

using nlib_ns::FileInputStream;
using nlib_ns::TextReader;

NLIB_PATHMAPPER_FORSAMPLE

bool SampleMain(int, char**) {
    // Initializes g_PathMapper which NLIB_PATHMAPPER_FORSAMPLE defines
    InitPathMapperForSample();

    // converts an URI to the corresponding native path
    char filename[1024];
    g_PathMapper.ResolvePath(NULL, filename, "nlibpath:///readonly/readfile.txt");

    std::string str;
    FileInputStream stream;
    nlib_printf("Reading: \'%s\'\n", filename);

    if (0 != stream.Init()) return false;
    if (0 != stream.Open(filename)) return false;

    TextReader reader;
    reader.Init(&stream);
    int c;
    while ((c = reader.Read()) > 0) {
        // The return value of TextReader::Read() is in UTF-32(UCS-4),
        // but readfile.txt is in ASCII.
        str += static_cast<char>(c);
    }
    if (reader.GetErrorValue() != 0) {
        return false;
    }
    nlib_printf("%s", str.c_str());
    return true;
}

NLIB_MAINFUNC
